---
stages:
  - generate pipelines
  - launch pipelines

cache:
  paths:
    - .cache/pip/

generate-pipelines:
  stage: generate pipelines
  image: python:3.6
  before_script:
    - pip3 install jinja2
  script:
    - python3 ./cicd/scripts/generate-site-pipelines.py
  artifacts:
    expire_in: 1 week
    untracked: true
  only:
    refs:
      - /^dev.*$/

{% for site in sites %}
launch {{ site }} pipeline:
  stage: launch pipelines
  trigger:
    include:
      - artifact: {{ site }}-pipeline.yml
        job: generate-pipelines
    strategy: depend
  only:
    refs:
      - /^dev.*$/
    changes:
      - cicd/tests/{{ site }}/*
      - cicd/scripts/*
      - cicd/templates/*
      - roles/**/*
      - playbooks/**/*
      - inventories/{{ site }}/**/*
      - .gitlab-ci.yml
{% endfor %}
